<template>
    <div class="card shadow mb-4">
        <form @submit.prevent="onSubmit()">
            <div
                class="card-header bg-white py-3 d-flex flex-row align-items-center justify-content-end"
            >
                <a @click="onExit" type="button"
                    ><i class="fa fa-times" aria-hidden="true"></i
                ></a>
            </div>
            <div class="card-body px-5">
                <div class="row align-items-center">
                    <div class="col-12 col-md-4">
                        <div class="row">
                            <div class="col-12 text-center">
                                <img
                                    :src="dataObject.image_path"
                                    class="img-thumbnail"
                                    width="200px"
                                    height="200px"
                                    @click="disabled ? '' : $refs.fileInput.click()"
                                    :role="disabled ? '' : 'button'"
                                />
                                <div v-show="!disabled" class="justify-content-center mt-3">
                                    <label class="btn btn-primary btn-sm m-1">
                                        Browse
                                        <input
                                            type="file"
                                            accept="image/*"
                                            @change="onImageChange"
                                            ref="fileInput"
                                            hidden
                                        />
                                    </label>
                                    <button
                                        type="button"
                                        class="btn btn-secondary btn-sm m-1"
                                        @click="onImageReset"
                                    >
                                        Reset
                                    </button>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="col-12 col-md-8">
                        <div class="row align-items-end">
                            <div class="col-12">
                                <div class="text-xs text-uppercase mb-1">
                                    Description
                                </div>
                                <input
                                    type="text"
                                    v-model="dataObject.description"
                                    class="form-control"
                                    placeholder="Description"
                                    tabindex="2"
                                    ref="description"
                                    :disabled="disabled"
                                />
                            </div>
                            <div class="col-12 col-md-6">
                                <label for="selectLeaveType">Leave Type</label>
                                <multi-select
                                    v-model="dataObject.classifier_type"
                                    :options="leaveType"
                                    track-by="value"
                                    label="name"
                                    placeholder="Select Type"
                                    :disabled="disabled"
                                ></multi-select>
                            </div>
                            <div class="col-12 col-md-6">
                                <label for="selectUser">User</label>
                                <multi-select
                                    v-model="dataObject.user"
                                    :options="users"
                                    track-by="id"
                                    label="full_name"
                                    placeholder="Select User"
                                    :disabled="disabled"
                                ></multi-select>
                            </div>
                            <div class="col-12 col-md-6">
                                <label for="inputstart_at">Start At</label>
                                <b-date-picker
                                    v-model="dataObject.start_at"
                                    :max="dataObject.end_at"
                                    :disabled="disabled"
                                ></b-date-picker>
                            </div>
                            <div class="col-12 col-md-6">
                                <label for="inputend_at">End At</label>

                                <b-date-picker
                                    v-model="dataObject.end_at"
                                    :min="dataObject.start_at"
                                    :disabled="disabled"
                                ></b-date-picker>
                            </div>
                            <div
                                v-show="!disabled"
                                class="col-12 col-md-2 ml-auto"
                            >
                                <input
                                    type="submit"
                                    class="btn btn-primary btn-block"
                                    tabindex="4"
                                    :value="
                                        isAction('create') ? 'Save' : 'Update'
                                    "
                                    :disabled="isDisabledButton"
                                />
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </form>
    </div>
</template>

<script>
import Swal from "sweetalert2";
import MultiSelect from "vue-multiselect";
import BDatePicker from "../DatePickerComponent";
export default {
    components: {
        MultiSelect,
        BDatePicker
    },
    props: ["disabled"],
    data() {
        return {
            dataObject: {
                image: "",
                image_path: "/img/no_image.jpg",
                description: "",
                type: "",
                user: [],
                start_at: new Date().toISOString().slice(0, 10),
                end_at: new Date().toISOString().slice(0, 10)
            },
            isDisabledButton: false,
            dataAction: "create",
            reset_image: false,
            isChanges: false,
            users: [],
            leaveType: [],
            unwatch: {}
        };
    },
    created() {
        this.prepare();
        this.debounce = _.debounce(this.chainUnwatch, 10000);
    },
    mounted() {
        this.$refs.description.focus();
        this.debounce();
    },
    methods: {
        chainUnwatch() {
            //dynamic watch use only once and destroy itself
            this.unwatch = this.$watch(
                "dataObject",
                function(oldValue, newValue) {
                    if (newValue) {
                        this.isChanges = true;
                        this.unwatch();
                    }
                },
                { deep: true }
            );
        },
        async prepare() {
            this.getLeaveType();
            this.getUsers();

            if (this.$route.params.id) {
                this.dataAction = "edit";
                this.getObject();
            }
        },
        getLeaveType() {
            axios
                .get("/api/classifier/list/leaves/type")
                .then(res => {
                    this.leaveType = res.data;
                })
                .catch(err => {
                    console.log(err.message);
                });
        },
        getUsers() {
            axios
                .get("/api/user/all")
                .then(res => {
                    this.users = res.data;

                    axios
                        .get("/api/user/get/" + this.$userId)
                        .then(res => {
                            this.dataObject.user = res.data;
                        })
                        .catch(err => {
                            console.warn(err.message);
                        });
                })
                .catch(err => {
                    console.log(err.message);
                });
        },
        getObject() {
            return axios
                .get("/api/leave/get/" + this.$route.params.id)
                .then(res => {
                    this.dataObject = res.data;

                    if (this.dataObject.image_path) {
                        this.dataObject.image_path =
                            "/storage/leaves/" + this.dataObject.image_path;
                    } else {
                        this.dataObject.image_path = "/img/no_image.jpg";
                    }
                })
                .catch(err => {
                    console.warn(err.message);
                });
        },
        onSubmit() {
            if (this.isDisabledButton) {
                return;
            }

            this.isDisabledButton = true;

            let formData = new FormData();

            formData.append("description", this.dataObject.description ?? "");
            formData.append("type", this.dataObject.classifier_type.value ?? "");
            formData.append("user_id", this.dataObject.user.id ?? "");
            formData.append("start_at", this.dataObject.start_at ?? "");
            formData.append("end_at", this.dataObject.end_at ?? "");
            formData.append("image", this.dataObject.image ?? "");
            formData.append("reset_image", this.reset_image ?? false);

            if (this.isAction("create")) {
                axios
                    .post("/leave", formData)
                    .then(res => {
                        Swal.fire("Created!", "", "success").then(result => {
                            this.$router.push({
                                name: "LeaveIndex"
                            });
                        });
                    })
                    .catch(err => {
                        console.warn(err.response);
                        Swal.fire(
                            "Error!",
                            err.response.data.errors.name[0],
                            "error"
                        );
                    })
                    .then(res => {
                        this.isDisabledButton = false;
                    });
            } else if (this.isAction("edit")) {
                formData.append("_method", "patch");

                axios
                    .post("/leave/" + this.dataObject.id, formData)
                    .then(res => {
                        Swal.fire("Updated!", "", "success").then(result => {
                            this.$router.push({
                                name: "LeaveIndex"
                            });
                        });
                    })
                    .catch(err => {
                        console.warn(err.response);
                        Swal.fire(
                            "Error!",
                            err.response.data.errors.name[0],
                            "error"
                        );
                    })
                    .then(res => {
                        this.isDisabledButton = false;
                    });
            }
        },
        isAction(value) {
            return this.dataAction == value;
        },
        onImageChange(e) {
            let files = e.target.files || e.dataTransfer.files;
            if (files.length) {
                this.reset_image = false;
                this.dataObject.image = files[0];
                this.createImage(files[0]);
            }
        },
        onImageReset() {
            this.reset_image = true;
            this.dataObject.image = null;
            this.$refs.fileInput.value=null;
            this.dataObject.image_path = "/img/no_image.jpg";
        },
        createImage(file) {
            let reader = new FileReader();
            reader.onload = e => {
                this.dataObject.image_path = e.target.result;
            };
            reader.readAsDataURL(file);
        },
        onExit() {
            if (this.isChanges) {
                Swal.fire({
                    title: "Do you want to exit?",
                    icon: "warning",
                    showCancelButton: true
                }).then(result => {
                    if (result.isConfirmed) {
                        this.$router.push({
                            name: "LeaveIndex"
                        });
                    }
                });
            } else {
                this.$router.push({
                    name: "LeaveIndex"
                });
            }
        },
    },
    computed: {}
};
</script>
